// Define the name of the application
var appname = "LiveViewJSApp";

// Create the application
var app = angular.module(appname,['ui.bootstrap']);

// Run once the document is loaded
angular.element(document).ready(function() {

	// Obtain resources
	var initInjector = angular.injector(['ng']);
	var $http = initInjector.get('$http');
	var $log = initInjector.get('$log');
	
	// Define configuration files
	var config = [ 
		//{"type": "columns", "url": "./config/columns.json"}
	];
	
	// Iterate over the configurations and load them
	var completed = 0;
	var referenceData = new Object();;
	for(var idx = 0; idx < config.length; idx++) {
		var url = config[idx].url;
		$http.get(url).success(
			function (response) {
				var type = Object.keys(response)[0];
				referenceData[type] = response[type];
				completed++;
			}
		);
	}

	// Define waitForReady function
	var waitForReady = function(){
		if(completed == config.length) {
			app.constant('ReferenceData', referenceData);
			angular.bootstrap(document, [appname]);				
		}
		else {
			setTimeout(function(){
				waitForReady();
			},250);
		}
	};

	// Wait until all reference data is loaded before returning
	waitForReady();
});
