app.controller('NavigationCtrl', function($scope, $log){

	$scope.setTab = function(newValue){
		$scope.tab = newValue;
		$scope.$applyAsync();
	};
	
	$scope.getTab = function(){
		
		return $scope.tab;
	};
});

app.controller('FXPricingSampleCtrl', function($scope, $modal, $log, NumberFormat, SeparateDigits, AlertMe, Properties){
	var controller = 'FXPricingSampleCtrl';
	var ldm_configurl = 'config/fxpricing-sample.json';

	$scope.lvconn = new LVControllerConnection({
		scope:		$scope,
		log:		$log,
		controller:	controller,
		configurl: 	ldm_configurl,
		url:		'/lv/client'
	});
	
	$scope.lvconn.init();
	
	Properties.setProperty("lvconn",$scope.lvconn);
		
	// Setup display variable for the query modal
	$scope.display = {};

	//  ADDED BELOW HERE
	$scope.dataset = new Collection(['Currency1', 'Currency2']);
	
	$scope.configPair = Properties.getProperty('ConfigPair');
	
	if($scope.configPair == null){
		$scope.configDataset = new Collection(['Currency1', 'Currency2']);
	}
		
	// Listen to subscribe events
	var pair;
	$scope.$on('query:FXPricingSample:subscribe', function(event, action, serverEvent, object) {
		
		if(action == 'onInsert' || action == 'onUpdate') {	
			pair = $scope.dataset.get(object.Currency1 + '|' + object.Currency2);
			if(pair == null) {
				pair = {
					Currency1: object.Currency1,
					Currency2: object.Currency2,
					promoted: object,
					ladder: new Collection(['tid'])
				};
				if($scope.configPair == null){
					configPair = {
						Currency1: object.Currency1,
						Currency2: object.Currency2,
						Active: true
					};
					$scope.configDataset.add(configPair);
					Properties.setProperty('ConfigPair', $scope.configDataset);
				}
				$scope.dataset.add(pair);
			}
			
			pair.ladder.add(object);
		}
		else if(action == 'onDelete') {
			//$scope.dataset.remove(object.tid);
		}
		$scope.$apply();		
		//$log.debug($scope.dataset);
	});
	
/*	$(function() {
		$('#AUDUSD').bootstrapToggle({
			on: 'Enabled',
			off: 'Disabled'
		});
	})
	*/
	
	$scope.editUser = function(pair) {
		$scope.$parent.fred = 'fred';
		$scope.$applyAsync();
	};
	
	$scope.promote = function(pair, rung) {
		pair.promoted = rung;
		$scope.$applyAsync();
	};
	
	$scope.formatNumber = function(str, format) {
		return NumberFormat.format(str, format);	
	};

	$scope.separateNumber = function(data,start,length) {
		return SeparateDigits.format(data,start,length);	
	};
	
	$scope.isActive = function(pair) {
		if($scope.configPair){
			configPair = $scope.configPair.objects[pair.Currency1 + '|' + pair.Currency2];
			return configPair.Active;
		}
		return true;	
	};
	
	$scope.AlertMe = function() {
		alert('hello controller');	
	};

	$scope.animationsEnabled = true;

	$scope.open = function (size, tradePair, side) {
		$scope.ccypair = tradePair.Currency1 + tradePair.Currency2;
	
		var buyorsell;
		
		var qtyLookup = {"1M":1000000,"3M":3000000,"5M":5000000};
 
    	var items = {};
    	
		for (var obj in tradePair.ladder.objects) {
			var key = tradePair.ladder.objects[obj].Volume;
			var price;
			
			if(side=='Long'){
				price = tradePair.ladder.objects[obj].Ask;
				buyorsell = "Select BUY quantity";
			}else{
				price = tradePair.ladder.objects[obj].Bid;
				buyorsell = "Select SELL quantity";
			}
    		
    		
   			items[key] = {
   				Vol: tradePair.ladder.objects[obj].Volume,
        		Price: price
        	};
    		
    	}
    	$scope.buyorsell = buyorsell;
		$scope.items = items;
		$scope.instrument = null;
   		$log.debug($scope.buyorsell);
    	
    	var modalInstance = $modal.open({
      		animation: $scope.animationsEnabled,
     		templateUrl: 'templates/modal-contents.html',
      		controller: 'ModalInstanceCtrl',
      		size: size,
      		resolve: {
      			tradePair: function() {
      				return tradePair;      			
      			},
      			something: function() {
      				return 'blah blah';
      			},
        		items: function () {
          			return $scope.items;
        		},
        		ccypair: function (){
        			return $scope.ccypair;
        		},
        		buyorsell: function (){
        		      return $scope.buyorsell;
        		},
        		instrument: function (){
        		      return $scope.instrument;
        		}
       		}
   		 });

    	modalInstance.result.then(function (selectedItem) {
      	$scope.selected = selectedItem;
         
		// SEND TUPLE

		var key = new Date().getTime() + "." + Math.random();
		
		$scope.request = {
			ClientID: "8sdfbvsb2345rbhjsbf1234rdsfk",
			Currency1: tradePair.Currency1,
			Currency2: tradePair.Currency2,
			Tier: "A",
			Volume: selectedItem.Vol,
			Quantity: qtyLookup[selectedItem.Vol],
			Price: selectedItem.Price,
			Side: side
		};
		
		$log.debug($scope.request);
		
		$scope.$on("lvconn", function(obj){$log.debug(obj)});
		
		$scope.lvconn.sendTuple(key, "sb://localhost:10001", "FXPricing.WorkingProcessor.ExecutionSimulator.ExecutionRequests", $scope.request);
      
    }, function () {
      $log.info('Modal dismissed at: ' + new Date());
    });
    
    
  };

  $scope.toggleAnimation = function () {
    $scope.animationsEnabled = !$scope.animationsEnabled;
  };
});

app.controller('ModalInstanceCtrl', function ($scope, $modalInstance, items, ccypair, buyorsell, instrument) {

	$scope.ccypair = ccypair;
	$scope.buyorsell = buyorsell;
	$scope.items = items;
	$scope.selected = {
    	item: $scope.items[0]
	};
	$scope.instrument = instrument;
		 

	$scope.ok = function () {
		$modalInstance.close($scope.selected.item);
	};
	
	$scope.cancel = function () {
		$modalInstance.dismiss('cancel');
	};
		
	$scope.submit = function() {
		$modalInstance.close($scope.instrument);
	};
	
});

app.controller('FXPositionsCtrl', function($scope, $log){
	var controller = 'FXPositionsCtrl';
	var ldm_configurl = 'config/fxpricing-sample.json';

	$scope.lvconn = new LVControllerConnection({
		scope:		$scope,
		log:		$log,
		controller:	controller,
		configurl: 	ldm_configurl,
		url:		'/lv/client'
	});
	$scope.lvconn.init();

	$scope.doit = function() {
		$('#content').toggle();
	};
	
	$scope.$on("table:onSelect", function(event, row) {
		// Display modal
		// Bind object
		$scope.object = row.data;
		//$log.debug("selected row");
		//$log.debug(row);
	});		
});

app.controller('FXConfigurationCtrl', function($scope, $modal, $log, Properties){
	var controller = 'FXConfigurationCtrl';
	var ldm_configurl = 'config/fxpricing-sample.json';

	$scope.lvconn = new LVControllerConnection({
		scope:		$scope,
		log:		$log,
		controller:	controller,
		configurl: 	ldm_configurl,
		url:		'/lv/client'
	});
	$scope.lvconn.init();
		
	// Setup display variable for the query modal
	$scope.display = {};	
	$scope.configPair = Properties.getProperty('ConfigPair');

	
	
	$scope.$on('ConfigPair', function(event, configPair){

		$scope.configPair = configPair;
		$scope.$apply();
	});
	
		
		
	$scope.open = function (size, tradePair, side) {
		$scope.ccypair = tradePair.Currency1 + tradePair.Currency2;
	
		$scope.buyorsell = '';
		$scope.items = '';
		$scope.instrument = {
			Currency1 : tradePair.Currency1,
			Currency2 : tradePair.Currency2,
			Tier : 'A',
			Volume : '1M',
			Pips : 22
		}
   		$log.debug($scope.buyorsell);
    			
    	var modalInstance = $modal.open({
      		animation: $scope.animationsEnabled,
     		templateUrl: 'templates/modal-spread.html',
      		controller: 'ModalInstanceCtrl',
      		size: size,
      		resolve: {	
        		items: function () {
          			return $scope.items;
        		},
        		ccypair: function (){
        			return $scope.ccypair;
        		},
        		buyorsell: function (){
        		      return $scope.buyorsell;
        		},
        		instrument: function (){
        		      return $scope.instrument;
        		}
       		}
   		 });

    	modalInstance.result.then(function (instrument) {
      	$scope.instrument = instrument;
         
		// SEND TUPLE

		var key = new Date().getTime() + "." + Math.random();
		
		
		$log.debug($scope.instrument);
		
		$scope.$on("lvconn", function(obj){$log.debug(obj)});
		
		$scope.lvconn.sendTuple(key, "sb://localhost:10001", "FXPricing.WorkingProcessor.FXSetup.ManualSpreadUpdate", $scope.instrument);
		modalInstance.close($scope.instrument);
      
    }, function () {
      $log.info('Modal (Spread) dismissed at: ' + new Date());
    });
    
    
  };
		
		
		
		
});

app.controller('LiveChartCtrl', function($scope,  $log){
	var controller = 'LiveChartCtrl';
	var ldm_configurl = 'config/fxpricing-sample.json';

	$scope.lvconn = new LVControllerConnection({
		scope:		$scope,
		log:		$log,
		controller:	controller,
		configurl: 	ldm_configurl,
		url:		'/lv/client'
	});
	$scope.lvconn.init();
});


